/* cu_sock.c - client for udp-socket */

#include "inet.h"
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>


/* read from 0, write to socket, read from socket, write to 1 */

void talk(int sockfd,struct sockaddr *pserv_addr,int servlen)
{
  int n;
  char sendline[MAXLINE];

  while (write(1,"c> ",3),(n = read(0,sendline, MAXLINE)) > 0) {
    if (sendto(sockfd, sendline, n,0,pserv_addr,servlen) != n) break;
    if ((n=recvfrom(sockfd,sendline,MAXLINE,0,(struct sockaddr *) 0,
                            (socklen_t *) 0)) <= 0) break;
    write(1,sendline,n);
  }
}
int main(int argc,char *argv[])
{
   int sockfd;
   struct sockaddr_in serv_addr, cli_addr;
   struct hostent *hp;

   if (argc != 2) {
     fprintf(stderr,"use: %s <IP-Adresse>|<Hostname>\n",argv[0]);
     exit(1);
   }
   bzero((char *) &serv_addr, sizeof(serv_addr));
   if ( ( hp = gethostbyname(argv[1])) != NULL) {
       (void) memcpy(&serv_addr.sin_addr.s_addr, *hp->h_addr_list,
                      sizeof (serv_addr.sin_addr.s_addr));
   } else {
        serv_addr.sin_addr.s_addr = inet_addr(argv[1]);
   }
   fprintf(stderr,"Addr: %8x\n",serv_addr.sin_addr.s_addr);
   if (serv_addr.sin_addr.s_addr == -1 ){
      fprintf(stderr,"Wrong address: %s\n",argv[1]);
      exit(-3);
   }
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_port = htons(SERV_UDP_PORT);

   if ((sockfd = socket(AF_INET,SOCK_DGRAM,0)) < 0) {
      fprintf(stderr,"cu_sock: can't open stream socket\n");
      exit(-1);
   }
   bzero((char *) &cli_addr, sizeof(cli_addr));
   cli_addr.sin_family = AF_INET;
   cli_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   cli_addr.sin_port = htons(0);
   if (bind(sockfd,(struct sockaddr *) &cli_addr,
                                  sizeof(cli_addr)) < 0){
         fprintf(stderr,"cu_sock: can't bind port\n");
         exit(-2);
   }
   talk(sockfd,(struct sockaddr *) &serv_addr, sizeof(serv_addr));
   exit(0);
}

